# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%define section free
%define bname   spring-security

%define upstream_tag .RELEASE
%define upstream_version %{version}%{?upstream_tag}

Name:           spring-security2
Summary:        Spring Security
Version:        2.0.5
Release:        1%{?dist}
Epoch:          0
License:        ASL 2.0
Group:          Development/Libraries/Application Frameworks
URL:            http://www.springframework.org/
# svn export https://src.springframework.org/svn/spring-security/tags/spring-security-2.0.5.RELEASE/
# tar czf ../SOURCES/spring-security-2.0.5.RELEASE.tgz spring-security-2.0.5.RELEASE/

Source0:        %{bname}-%{upstream_version}.tgz
Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        jets3t.jar

Patch0:         spring-security2-BindAuthenticator.patch
Patch1:         spring-security2-core-template-mf.patch
Patch2:         spring-security2-core-tiger-template-mf.patch
Patch3:         spring-security2-Jsr250MethodDefinitionSourceTests.patch
Patch4:         spring-security2-DefaultInitialDirContextFactory.patch
Patch5:         spring-security2-openid-pom.patch
Patch6:         spring-security2-openid-template-mf.patch
Patch7:         spring-security2-taglibs-pom.patch
Patch8:         spring-security2-taglibs-template-mf.patch
Patch9:         spring-security2-cas-template-mf.patch
Patch10:        spring-security2-MockSpringSecurityContextSource.patch

BuildArch:      noarch
BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7
BuildRequires:  junit44
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-eclipse
BuildRequires:  maven2-plugin-help
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-war
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  docbkx
BuildRequires:  jetty6-maven2-plugins
BuildRequires:  spring-build-aws-maven
BuildRequires:  springsource-bundlor
BuildRequires:  springsource-util

BuildRequires:  annotation_1_0_api
BuildRequires:  apacheds-shared-ldap
BuildRequires:  apacheds10-core
BuildRequires:  apacheds10-server-jndi
BuildRequires:  aspectj >= 0:1.5.3
BuildRequires:  cas-client
BuildRequires:  ehcache >= 0:1.3.0
BuildRequires:  glassfish-jstl
BuildRequires:  google-guice
BuildRequires:  hessian-nodep
BuildRequires:  hsqldb
BuildRequires:  jakarta-taglibs-standard
BuildRequires:  jcifs
BuildRequires:  jsp_2_0_api
BuildRequires:  log4j
BuildRequires:  mina11-filter-ssl
BuildRequires:  openid4java
BuildRequires:  org.osgi.core
BuildRequires:  portlet-1.0-api
BuildRequires:  servlet_2_4_api
BuildRequires:  servlet_2_5_api
BuildRequires:  slf4j
BuildRequires:  spring-ldap >= 0:1.3.0
BuildRequires:  spring2-aop
BuildRequires:  spring2-core
BuildRequires:  spring2-jdbc
BuildRequires:  spring2-test
BuildRequires:  spring2-web
BuildRequires:  spring2-webmvc
BuildRequires:  spring2-webmvc-portlet
BuildRequires:  tomcat6-lib

Requires:       java >= 0:1.6.0
Requires:       java-fonts

Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Spring is a layered Java/J2EE application framework, 
based on code published in Expert One-on-One J2EE 
Design and Development by Rod Johnson (Wrox, 2002). 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package devel
Summary:        Source jars for %{name}
Group:          Development/Java

%description devel
%{summary}.

%prep
%setup -q -n %{bname}-%{upstream_version}

%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2
%patch3 -b .sav3
%patch4 -b .sav4
%patch5 -b .sav5
%patch6 -b .sav6
%patch7 -b .sav7
%patch8 -b .sav8
%patch9 -b .sav9
%patch10 -b .sav10

cp -p %{SOURCE1} settings.xml
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml

%build
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p ${MAVEN_REPO_LOCAL}

mkdir -p ${MAVEN_REPO_LOCAL}/net/java/dev/jets3t/jets3t/0.7.2/
cp %{SOURCE3} ${MAVEN_REPO_LOCAL}/net/java/dev/jets3t/jets3t/0.7.2/jets3t-0.7.2.jar

export MAVEN_SETTINGS=$(pwd)/settings.xml
export MAVEN_OPTS="-Xmx256m -XX:MaxPermSize=128m"

%{_bindir}/mvn-jpp \
        -e \
        -s ${MAVEN_SETTINGS} \
        -Dmaven.test.failure.ignore=true \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        install

%{_bindir}/mvn-jpp \
        -e \
        -s ${MAVEN_SETTINGS} \
        -Daggregate=true \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        javadoc:javadoc


%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}-sources
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}-tests

install -m 644 acl/target/spring-security-acl-%{upstream_version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/acl-%{version}.jar
install -m 644 acl/target/spring-security-acl-%{upstream_version}-sources.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-sources/acl-%{version}.jar
install -m 644 acl/target/spring-security-acl-%{upstream_version}-tests.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-tests/acl-%{version}.jar
install -m 644 cas/target/spring-security-cas-client-%{upstream_version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/cas-client-%{version}.jar
install -m 644 cas/target/spring-security-cas-client-%{upstream_version}-sources.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-sources/cas-client-%{version}.jar
install -m 644 cas/target/spring-security-cas-client-%{upstream_version}-tests.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-tests/cas-client-%{version}.jar
install -m 644 core/target/spring-security-core-%{upstream_version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/core-%{version}.jar
install -m 644 core/target/spring-security-core-%{upstream_version}-sources.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-sources/core-%{version}.jar
install -m 644 core/target/spring-security-core-%{upstream_version}-tests.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-tests/core-%{version}.jar
install -m 644 core-tiger/target/spring-security-core-tiger-%{upstream_version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/core-tiger-%{version}.jar
install -m 644 core-tiger/target/spring-security-core-tiger-%{upstream_version}-sources.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-sources/core-tiger-%{version}.jar
install -m 644 core-tiger/target/spring-security-core-tiger-%{upstream_version}-tests.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-tests/core-tiger-%{version}.jar
install -m 644 ntlm/target/spring-security-ntlm-%{upstream_version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/ntlm-%{version}.jar
install -m 644 ntlm/target/spring-security-ntlm-%{upstream_version}-sources.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-sources/ntlm-%{version}.jar
install -m 644 ntlm/target/spring-security-ntlm-%{upstream_version}-tests.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-tests/ntlm-%{version}.jar
install -m 644 openid/target/spring-security-openid-%{upstream_version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/openid-%{version}.jar
install -m 644 openid/target/spring-security-openid-%{upstream_version}-sources.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-sources/openid-%{version}.jar
install -m 644 openid/target/spring-security-openid-%{upstream_version}-tests.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-tests/openid-%{version}.jar
install -m 644 portlet/target/spring-security-portlet-%{upstream_version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/portlet-%{version}.jar
install -m 644 portlet/target/spring-security-portlet-%{upstream_version}-sources.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-sources/portlet-%{version}.jar
install -m 644 portlet/target/spring-security-portlet-%{upstream_version}-tests.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-tests/portlet-%{version}.jar
install -m 644 taglibs/target/spring-security-taglibs-%{upstream_version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/taglibs-%{version}.jar
install -m 644 taglibs/target/spring-security-taglibs-%{upstream_version}-sources.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-sources/taglibs-%{version}.jar
install -m 644 taglibs/target/spring-security-taglibs-%{upstream_version}-tests.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-tests/taglibs-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name}-sources && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name}-tests && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

%add_to_maven_depmap org.springframework.security %{bname}-acl %{upstream_version} JPP/%{name} acl
%add_to_maven_depmap org.springframework.security %{bname}-cas %{upstream_version} JPP/%{name} cas
%add_to_maven_depmap org.springframework.security %{bname}-core %{upstream_version} JPP/%{name} core
%add_to_maven_depmap org.springframework.security %{bname}-core-tiger %{upstream_version} JPP/%{name} core-tiger
%add_to_maven_depmap org.springframework.security %{bname}-ntlm %{upstream_version} JPP/%{name} ntlm
%add_to_maven_depmap org.springframework.security %{bname}-openid %{upstream_version} JPP/%{name} openid
%add_to_maven_depmap org.springframework.security %{bname}-portlet %{upstream_version} JPP/%{name} portlet
%add_to_maven_depmap org.springframework.security %{bname}-taglibs %{upstream_version} JPP/%{name} taglibs
%add_to_maven_depmap org.springframework.security %{bname}-parent %{upstream_version} JPP/%{name} parent

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 acl/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-org.springframework.aop.pom
install -m 644 acl/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-acl.pom
install -m 644 cas/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-cas.pom
install -m 644 core/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-core.pom
install -m 644 core-tiger/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-core-tiger.pom
install -m 644 ntlm/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-ntlm.pom
install -m 644 openid/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-openid.pom
install -m 644 portlet/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-portlet.pom
install -m 644 taglibs/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-taglibs.pom
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-parent.pom

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%dir %{_javadir}/%{name}-tests
%{_javadir}/%{name}-tests/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%files devel
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}-sources
%{_javadir}/%{name}-sources/*.jar

%changelog
* Sat Jun 25 2011 Ralph Apel <r.apel@r-apel.de> 0:2.0.5-1
- First release

